static char rcsid[] = "@(#)$Id: write_hdr.c,v 2.0 2007/08/25 11:51:37 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 2.0 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI> (was hurtta+elm@ozone.FMI.FI)
 *      or  Kari Hurtta <elm@elmme-mailer.org>
 *****************************************************************************/

#include "elm_defs.h"

DEBUG_VAR(Debug,__FILE__,"header");

void print_EOLN(mailer,top_encoding) 
     out_state_t *mailer;
     int top_encoding;
{  
    /* Write canonocal end of line if we are sending binary mail 
     * Also SMTP requires \r\n
     */
    if (top_encoding == ENCODING_BINARY || mailer->EOLN_is_CRLF)
	state_putc('\r',mailer);
    state_putc('\n',mailer);
}

#define LEN (out_state_ftell(mailer)-POS)
#define WRAP print_EOLN(mailer,top_encoding), \
 (POS = out_state_ftell(mailer)), state_putc(' ',mailer)

void write_text_header (mailer,hdr_name,text, top_encoding)
     out_state_t *mailer;
     const char *hdr_name; 
     const char * text;
     int top_encoding;
{
    long POS = out_state_ftell(mailer);
    const char *c;

    state_puts(hdr_name,mailer);
    state_puts(": ",mailer);

    DPRINT(Debug,9,
	   (&Debug,"write_text_header: %s:",hdr_name));
    
    for (c = text; *c != '\0'; c++) {
	if (*c == '\n' || 
	    (whitespace(*c) && (LEN > 75))) {
	    WRAP;
	    DPRINT(Debug,9,
		   (&Debug,"[WRAP]\n          "));
	} else {
	    state_putc(*c,mailer);
	    DPRINT(Debug,9,
		   (&Debug,"%c",*c));
	}
    }
    print_EOLN(mailer,top_encoding);    
    DPRINT(Debug,9,
	   (&Debug,"[EOLN]\n"));
}

#undef LEN
#undef WRAP

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */

